package eu.semiramis.policymodel.policy;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import org.opensaml.DefaultBootstrap;
import org.opensaml.xacml.XACMLConstants;
import org.opensaml.xacml.ctx.RequestType;
import org.opensaml.xacml.ctx.ResponseType;
import org.opensaml.xacml.policy.ApplyType;
import org.opensaml.xacml.policy.ConditionType;
import org.opensaml.xacml.policy.EffectType;
import org.opensaml.xacml.policy.PolicyType;
import org.opensaml.xacml.policy.RuleType;
import org.opensaml.xacml.policy.TargetType;
import org.opensaml.xml.ConfigurationException;
import org.opensaml.xml.io.MarshallingException;

import eu.semiramis.policyManager.pdp.ContextHandler;
import eu.semiramis.policyManager.pdp.impl.ContextHandlerFactory;
import eu.semiramis.policyManager.util.opensaml.XACMLUtils;
import eu.semiramis.policymodel.request.AttributeReleaseRequest;
import eu.semiramis.policymodel.request.RoleBasedAccessRequest;
import eu.semiramis.policymodel.request.ServiceToServiceRequest;
import eu.semiramis.policymodel.response.AttributeReleaseResponseHandler;
import eu.semiramis.policymodel.response.RoleBasedAccessResponseHandler;
import eu.semiramis.policymodel.response.ServiceToServiceResponseHandler;
import eu.semiramis.policymodel.utils.PolicyModelXACMLPolicyUtils;
import eu.semiramis.policymodel.utils.PolicyModelXACMLUtils;


public class Main {
    public static void main(String[] args) throws Exception {
    
    	org.opensaml.DefaultBootstrap.bootstrap();   	
    	
    	File f = new File("D:/SEMIRAMIS_2.0/workspace/PolicyModel/contextHandler.properties");
		Properties pro = new Properties();
		if(f.exists()){
		  
		  FileInputStream i = null;
		try {
			i = new FileInputStream(f);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		  try {
			pro.load(i);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		}
    	ContextHandler handler = ContextHandlerFactory.createContextHandler(pro);

    
    
    /*AttributeReleasePolicy pG = new AttributeReleasePolicy("policyId2", "desc", "", "semiramis@um.es", "Name", "", true, true, "permit");
    PolicyType policyG = pG.toXACMLPolicy();
    System.out.println(XACMLUtils.printXMLObject(policyG));
    */
    
    //AttributeReleaseRequest (requester, attrProvider, attrOwner, attribute)
   AttributeReleaseRequest atr = new AttributeReleaseRequest("UMU", "attrProvider", "semiramis@um.es", "parent_gender");
	RequestType r = atr.toXACMLRequest();
	System.out.println(XACMLUtils.printXMLObject(atr.toXACMLRequest()));
	AttributeReleaseRequest ar = new AttributeReleaseRequest(r);
	System.out.println(" release target: " + ar.getRequester());
	System.out.println(" attrProvider: " + ar.getAttrProvider());
	System.out.println(" attrOwner: " + ar.getAttributeOwner());
	System.out.println(" requested attr name: " + ar.getRequestedAttributeName());
	//System.out.println(XACMLUtils.printXMLObject(ar.toXACMLRequest()));
	
	/*
	//ServiceToServiceRequest
	ServiceToServiceRequest ser = new ServiceToServiceRequest("OriginServiceName", "access", "targetServiceName");
    RequestType r2 = ser.toXACMLRequest();
    
    ServiceToServiceRequest ser2 = new ServiceToServiceRequest(r2);
	System.out.println(" origin service: " + ser2.getOriginService());
	System.out.println(" target service: " + ser2.getTargetService());
	System.out.println(" functionality: " + ser2.getFunctionality());
	System.out.println(XACMLUtils.printXMLObject(ser2.toXACMLRequest()));
	
	/*
	//nurserySubscriptionRequest*/
	/*RoleBasedAccessRequest rol = new RoleBasedAccessRequest("manager", "requested resource 1", "read");
    RequestType r3 = rol.toXACMLRequest();
    
    RoleBasedAccessRequest rol2 = new RoleBasedAccessRequest(r3);
	System.out.println(" role name: " + rol2.getRole());
	System.out.println(" requested resource: " + rol2.getRequestedResource());
	System.out.println(" functionality: " + rol2.getFunctionality());
	System.out.println(XACMLUtils.printXMLObject(rol2.toXACMLRequest()));
    	
    	//paolo-note: the openSAML bootstrap could be moved in Main, 
		//as the library initialization should be done only once, 
		//and the choice should be left to the external code
		
	
    	ServiceToServicePolicy p = new ServiceToServicePolicy("testingS2SPolicy", "UMU-SP", "AUTHENTICATION", "UMU-IA");
    	PolicyType policy = p.toXACMLPolicy();
    	
    	System.out.println("--------------------POLICY----------------");
    	System.out.println(XACMLUtils.printXMLObject(policy));
    	System.out.println("----------------END POLICY----------------");
    	
    	ServiceToServicePolicy p2 = new ServiceToServicePolicy(policy);
    	System.out.println(" target service: " + p2.getTargetService());
    	System.out.println(" origin service: " + p2.getOriginService());
    	
    	*//*
    	RoleBasedAccessPolicy p = new RoleBasedAccessPolicy("policyId", "manager", "requested resource 1", "functionality 1");
    	PolicyType policy = p.toXACMLPolicy();
    	
    	System.out.println("--------------------POLICY----------------");
    	System.out.println(XACMLUtils.printXMLObject(policy));
    	System.out.println("----------------END POLICY----------------");
    	
    	RoleBasedAccessPolicy p2 = new RoleBasedAccessPolicy(policy);
    	System.out.println(" target service: " + p2.getRequestedResource());
    	System.out.println(" origin service: " + p2.getRole());
    	  	
    	System.out.println(XACMLUtils.printXMLObject(p2.toXACMLPolicy()));
		
	
	
		AttributeReleasePolicy p = new AttributeReleasePolicy("policyId2", "descriptionnn", "attrProvider", "yo", "age", "UMU", true, true, "permit");
		//p.setDescription("description test");
    	PolicyType policy = p.toXACMLPolicy();
    	
    	System.out.println("--------------------POLICY----------------");
    	System.out.println(XACMLUtils.printXMLObject(policy));
    	System.out.println("----------------END POLICY----------------");
    	
    	AttributeReleasePolicy p2 = new AttributeReleasePolicy(policy);
    	System.out.println(" requester: " + p2.getRequester());
    	System.out.println(" attrProvider: " + p2.getAttrProvider());
    	System.out.println(" attrOwner: " + p2.getAttributeOwner());
    	System.out.println(" attribute id: " + p2.getAttributeName());
    	System.out.println(" desc: " + p2.getDescription());
    	  	
    	System.out.println(XACMLUtils.printXMLObject(p2.toXACMLPolicy()));
    	*/
	/*
    	ResponseType xacmlResponse = handler.handleRequest(r3);
		RoleBasedAccessResponseHandler RBAResponseHandler = new RoleBasedAccessResponseHandler();
		RBAResponseHandler.handle(xacmlResponse);
		System.out.println(RBAResponseHandler.isAuthorized());
	
	
    	ServiceToServiceRequest ser = new ServiceToServiceRequest("UMU-SP", "ATTRELEASE", "UMU-IA");
        RequestType r2 = ser.toXACMLRequest();
       */
    	ResponseType xacmlResponse = handler.handleRequest(r);
		AttributeReleaseResponseHandler ser2serResponseHandler = new AttributeReleaseResponseHandler();
		ser2serResponseHandler.handle(xacmlResponse);
		System.out.println(ser2serResponseHandler.isAuthorized());
    }
}
