package eu.semiramis.policymodel.request;

import javax.xml.parsers.ParserConfigurationException;
import org.opensaml.xacml.ctx.RequestType;
import org.opensaml.xml.ConfigurationException;
import eu.semiramis.policymodel.utils.PolicyModelXACMLRequestUtils;

public class RoleBasedAccessRequest extends PolicyModelXACMLRequestUtils implements Request {

	//urns RoleBasedAccess requests
	public static final String RBAC_SUBJECT_ID = "urn:semiramis:names:accesscontrol:rbac:subject:role-id";
	public static final String RBAC_ACTION_ID = "urn:semiramis:names:accesscontrol:rbac:action:functionality-id";
	public static final String RBAC_RESOURCE_ID	= "urn:semiramis:names:accesscontrol:rbac:resource:resource-id";
	
	private String requestedResource;
	private String role;
	private String functionality;

	/*******  Constructors  *******/
	public RoleBasedAccessRequest(String role, String requestedResource, String functionality) {
		this.requestedResource = requestedResource;
		this.role = role;
		this.functionality = functionality;
	}
	public RoleBasedAccessRequest(RequestType xacmlRequest) {
		try {
			init();
		} catch (ConfigurationException e) {
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		}
		RequestType xacmlReq = unMarshallXACMLRequest(xacmlRequest);
		this.requestedResource = xacmlReq.getResources().get(0).
	   			getAttributes().get(0).getAttributeValues().get(0).getValue();
		this.role = xacmlReq.getSubjects().get(0).
				getAttributes().get(0).getAttributeValues().get(0).getValue();
		this.functionality = xacmlReq.getAction().getAttributes().
    		get(0).getAttributeValues().get(0).getValue();
	}
	
	/*********  Methods	 **********/	
	
	@Override
	public RequestType toXACMLRequest() {
		try {
			init();
		} catch (ConfigurationException e) {
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		}
		return buildXACMLRequest(this);
	}

	/********Setters Getters********/
	public void setRequestedAttributeName(String requestedResource) {
		this.requestedResource = requestedResource;
	}
	public String getRequestedResource() {
		return requestedResource;
	}
	
	public void setRole(String releaseTarget) {
		this.role = releaseTarget;
	}
	public String getRole() {
		return role;
	}
	
	public void setFunctionality(String functionality) {
		this.functionality = functionality;
	}
	public String getFunctionality() {
		return functionality;
	}
}

