package eu.semiramis.policymodel.utils;

import java.io.InputStream;

import org.opensaml.xacml.ctx.ResponseType;
import org.opensaml.xml.io.Marshaller;
import org.opensaml.xml.io.MarshallingException;
import org.opensaml.xml.io.Unmarshaller;
import org.opensaml.xml.io.UnmarshallingException;
import org.opensaml.xml.parse.BasicParserPool;
import org.opensaml.xml.util.XMLHelper;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class PolicyModelXACMLResponseUtils extends PolicyModelXACMLUtils {

	//returns XACML PolicyType as a string
	protected String responseTypeToString(ResponseType response) {
		String output = "";
		Document doc = db.newDocument();
		
	    Marshaller marshallerPolicy = marshallerFactory
		    .getMarshaller(ResponseType.DEFAULT_ELEMENT_NAME);
	    Element element;
		try {
			element = marshallerPolicy.marshall(response, doc);
			output = XMLHelper.prettyPrintXML(element);
		} catch (MarshallingException e) {
			e.printStackTrace();
		}
	    return output;
	}
	
	protected ResponseType unMarshallXACMLResponse(ResponseType response) {
		try {
		    InputStream in = stringToInputStream(responseTypeToString(response));
		    BasicParserPool pool = new BasicParserPool();
		    Document doc = pool.parse(in);
		    Unmarshaller reqUnmarshaller = unMarshallerFactory
			    .getUnmarshaller(ResponseType.DEFAULT_ELEMENT_NAME);
		   return (ResponseType) reqUnmarshaller.unmarshall(doc.getDocumentElement());
		} catch (UnmarshallingException e) {
			System.out.println(e);
		} catch (Exception e) {
			System.out.println(e);
		}
		
		return null;
	}
	
}
